#include "stdafx.h"
#include "MyContentType.h"
#include "httphelper.h"

#define OCTET_STREAM	"application/octet-stream"
#define MIMETYPE_FILE_NAME L"\\AddType.txt"
//-----------------------------------------------------------------------------
//	@detail
//		
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
MyContentType::MyContentType()
{
	// ----------------------------------------------------
	// Loading default mime type
	// ----------------------------------------------------

	Set(".html",	"text/html"						);
	Set(".htm",		"text/html"						);
	Set(".gif",		"image/gif"						);
	Set(".png",		"image/png"						);
	Set(".jpg",		"image/jpeg"					);
	Set(".jpeg",	"image/jpeg"					);
	Set(".txt",		"text/plain"					);
	Set(".css",		"text/css"						);
	Set(".bmp",		"image/bitmap"					);
	Set(".tif",		"image/tiff"					);
	Set(".tiff",	"image/tiff"					);
	Set(".mpg",		"video/mpeg"					);
	Set(".mpeg",	"video/mpeg"					);
	Set(".pdf",		"application/pdf"				);
	Set(".ls",		"application/x-javascript"		);
	Set(".js",		"application/x-javascript"		);
	Set(".mp3",		"audio/mp3"						);
	Set(".m3u",		"audio/x-mpegurl"				);
	Set(".wav",		"audio/x-wav"					);
	Set(".mid",		"audio/mid"						);
	Set(".midi",	"audio/mid"						);
	Set(".swf",		"application/x-shockwave-flash"	);

	WCHAR pwszDir[MAX_PATH];

	// ----------------------------------------------------
	// Loading mime txt
	// ----------------------------------------------------

	GetCurrentDirW(pwszDir, MAX_PATH);
	wcscat(pwszDir, MIMETYPE_FILE_NAME);
	LoadFile(pwszDir);

	// ----------------------------------------------------
	// Loading modules
	// ----------------------------------------------------

	GetCurrentDirW(pwszDir, MAX_PATH);
	wcscat(pwszDir, L"\\");
	LoadModFile(pwszDir);
}

MyContentType::~MyContentType()
{
}

//-----------------------------------------------------------------------------
//	@detail
//		Serch mime-type from file-type
//	@param
//		cahr*	pszKey;		mimetype find key
//	@return
//		Mime type strings
//		This must not be null string
//-----------------------------------------------------------------------------
char* MyContentType::GetMimeType(char *pszExtend)
{
	char* p = SeekToKeyI(pszExtend);
	
	if( p == NULL )
	{
		// If mime type is unknown, set octet-stream.
		return OCTET_STREAM;
	}
	else
	{
		while(*p++ != '\0');
	}
	
	return p;
}

//-----------------------------------------------------------------------------
//	@detail
//		Seek key. perform a lowercase comparison.
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
char*	MyContentType::SeekToKeyI(char* pszKey)
{
	char* p = (char*) m_pHeap->GetBuffer();

	if( p == NULL )
	{
		return NULL;
	}

	while(StrCmpI(p, pszKey) != 0)
	{
		p = SeekNext(p);

		if( p == NULL )
			return NULL;
	}
	return (m_pszSeekPointer = p);
}

//-----------------------------------------------------------------------------
//	@detail
//		Seek next key
//	@param
//		char*	pszKey;	current key
//	@return
//		
//-----------------------------------------------------------------------------
char*	MyContentType::SeekNext(char* pszKey)
{
	if( pszKey == NULL )
	{
		return NULL;
	}
	char* p = pszKey;
		
	// Seek to head of 'value'
	while(*p++ != '\0');
	
	// 'value' is NULL
	if( p[0] == '\0' && p[1] == '\0' )
	{
		return NULL;
	}

	// Seek to next key.
	while(*p++ != '\0');

	// If terminate, return NULL.
	if( *p == '\0' )
	{
		pszKey = p;
		return NULL;
	}

	return (pszKey = p);
}

//-----------------------------------------------------------------------------
//	@detail
//		Loading  file written about mime-type
//	@param
//		WCHAR*	ptszFile;	file name	(UTF-2)
//	@return
//		0 indicate an error
//-----------------------------------------------------------------------------
int MyContentType::LoadFile(WCHAR* ptszFile)
{
	// --------------------------------------------------------------
	HANDLE hFile = CreateFile(ptszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	MyVarMem	vm;

	if( hFile == INVALID_HANDLE_VALUE )
	{
		return 0;
	}
	else
	{
		char	szBuf[510];
		BOOL	bResult;
		DWORD	dwReadBytes;
		do
		{
			bResult = ReadFile( hFile, szBuf, 510, &dwReadBytes, NULL );
			
			if(dwReadBytes == 0)
				break;

			vm.Add( szBuf, dwReadBytes );

		}while( bResult );

		CloseHandle(hFile);
	}

	if( vm.GetLength() == 0 )
	{
		return 0;
	}
	// ..File read end

	// --------------------------------------------------------------
	char*	pCurrentLine;
	char*	pNextLine;

	pCurrentLine = pNextLine = (char*)vm.GetBuffer();

	do
	{
		while( *pNextLine == '\r' ||  *pNextLine == '\n' )
			pNextLine++;

		if( *pNextLine == '\0' )
			return 0;

		pCurrentLine = pNextLine;

		while( *pNextLine != '\r' &&  *pNextLine != '\n' && *pNextLine != '\0' )
		{
			pNextLine++;
		}

		if( *pNextLine != '\0' )
			*pNextLine++ = '\0';
		
		if( *pCurrentLine == '#' )
		{
			continue;
		}
		else
		{
			char* pKey;
			char* pValue;

			pKey = pCurrentLine;
			pValue = pCurrentLine;

			while( *pValue != ' ' && *pValue != '\t' && *pValue != '\0' )
			{
				pValue++;
			}

			// there is no value;
			if( *pValue == '\0' )
				continue;

			*pValue++ = '\0';

			while( *pValue == ' ' || *pValue == '\t' )
			{
				pValue++;
			}

			Set(pKey, pValue);

		}

		// next line
	}while( *pNextLine != '\0' );
	return 1;
}

//-----------------------------------------------------------------------------
//	@detail
//		Loding modules
//	@param
//		WCHAR*	pwszDir;	directory	(UTF-2)
//	@return
//		0 indicate an error
//-----------------------------------------------------------------------------
int MyContentType::LoadModFile(WCHAR* pwszDir)
{
	HANDLE hFFF;
	WIN32_FIND_DATA wfdFile;

	WCHAR wszModuleFile[MAX_PATH];
	char szModuleFile[MAX_PATH];

	WCHAR wszFileStrip[MAX_PATH];
	char szFileStrip[MAX_PATH];
	
	WCHAR wszFindPath[MAX_PATH];
	wcscpy( wszFindPath, pwszDir );
	wcscat( wszFindPath, L"*.mod");

	hFFF = FindFirstFile( wszFindPath, &wfdFile );

	if( hFFF == INVALID_HANDLE_VALUE  )
		return 0;


	do
	{
		// file path
		wcscpy( wszModuleFile, pwszDir );
		wcscat( wszModuleFile, wfdFile.cFileName );

		// mime type
		WCHAR* pFileName = wfdFile.cFileName;
		WCHAR* pDst = wszFileStrip;

		*pDst++ = '.';

		while( *pFileName != '.' )
		{
			*pDst++ = *pFileName++;
		}
		*pDst = '\0';

		WideCharToMultiByte(CP_ACP, 0, wszFileStrip, -1, szFileStrip, MAX_PATH, NULL, NULL);
		WideCharToMultiByte(CP_ACP, 0, wszModuleFile, -1, szModuleFile, MAX_PATH, NULL, NULL);
		Set(szFileStrip, szModuleFile);

	}while( FindNextFile(hFFF, &wfdFile) );

	FindClose( hFFF );

	return 1;
}