#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include "httphelper.h"
#include "MyVarMem.h"
#include "MyHash.h"
#include "MyHttpSock.h"
#include "MyTime.h"

#ifndef _WIN32_WCE
#include <direct.h>
#endif

#include "resource.h"

#define	HEADER_LINE_MAX	512		// HeaderLines̈s̐l


#ifndef _WIN32_WCE
#define FNC_EXTEND_DLL	"fnCAPI"
#define FNC_EXTEND_CHX	"fnChx"
#else
#define FNC_EXTEND_DLL	L"fnCAPI"
#define FNC_EXTEND_CHX	L"fnChx"
#endif

// temporary buffers
#define SOCKET_HEAD_BUF	1024	// \Pbgpobt@TCY
#define SOCKET_BODY_BUF	4096	// \Pbgpobt@TCY

// strings
#define	STR_KEEP_ALIVE		"Keep-Alive"
#define STR_CLOSE			"Close"

#define LOG_SEND_DATA		"send_bytes"
#define LOG_REQUEST_LINE	"request_line"

//-----------------------------------------------
// [vĒTԂɂ̂ŁA0,2,5Ԃ͌ŒłB
#define HTTPSTATUS_200	0
#define HTTPSTATUS_302	2
#define HTTPSTATUS_401	5

HTTP_STATUS	hsStatus[] = 
{
	{200, "200 OK"								},	// 0
	{301, "301 Moved Permanently"				},
	{302, "302 Object Moved"					},	// 2
	{304, "304 Not Modified"					},
	{400, "400 Bad Request"						},
	{401, "401 Unauthorized"					},	// 5
	{403, "403 Access Forbidden"				},
	{404, "404 Object Not Found"				},
	{500, "500 Internal Server Error"			},
	{501, "501 Not Implemented"					},
	// {503, "503 Server busy"						},
	{999, "999 CGI"								},	// Ǝ
	{000, "500 Internal Server Error"			}	// terminate
};


//-----------------------------------------------
// content_type

MyContentType	g_ctMime;		// MIMETYPE

MyHttpSock::MyHttpSock()
{
	m_dwRecvTimeOut = 30000;
}

MyHttpSock::MyHttpSock(SOCKET s) : MySock(s)
{
	m_dwRecvTimeOut = 30000;

}

MyHttpSock::~MyHttpSock()
{
	FreeMemory();
}

//-----------------------------------------------------------------------------
//	@detail
//		HTTPNGXg͂AHTTPXe[^Xm
//	@param
//		int* pbClose	߂ɒʐM؂グtO
//	@return
//		0̓\Pbg֘AG[łȏʐMoȂ
//		ȊOHTTPXe[^XԂ
//-----------------------------------------------------------------------------
int MyHttpSock::RecvRequest(int* pbClose)
{
	char szHeadBuf[SOCKET_HEAD_BUF];
	m_hReqHead.Clear();
	m_hReqBody.Clear();
	timeval ptvTimeOut;
	char* pReq = NULL;
	strcpy(m_hrHttpReq.szHttpVer, "HTTP/1.0");

	GetTimeOut(&ptvTimeOut);

	//-------------------------------------------
	// Recive process
	//-------------------------------------------

	// Get http header
	DWORD	dwStartTime = GetTickCount();
	MyVarMem hReq;// = new MyVarMem;
	int nRecvLen;

	while(1)
	{
		char*	p;
		memset( szHeadBuf, 0, SOCKET_HEAD_BUF );
		nRecvLen = RecvData( szHeadBuf, SOCKET_HEAD_BUF );

		if( nRecvLen == SOCKET_ERROR )		//*** socket error
		{
			Close();
			return 0;
		}
		else if( nRecvLen > 0 )				//*** M
		{
			// RFC2626 sec.5
			hReq.Add((void*)szHeadBuf, nRecvLen);

			// Judge end of header
			const char* pszReqHeadBuf = (const char*)hReq.GetBuffer();

			p = strstr(pszReqHeadBuf, "\r\n\r\n");

			if( p )
			{
				p += 4;
			}
			else 
			{
				p = strstr(pszReqHeadBuf, "\n\n");
				
				if( p )
				{
					p += 2;
				}
			}

			// header is end.
			if( p != NULL )
			{
				// p += 4;
				// Add read header block to m_ReqHead.
				int nHeaderLen = (p - pszReqHeadBuf);
				m_hReqHead.Add(hReq.GetBuffer(), nHeaderLen);
				
				// A part to have over taken is added to a m_hReqBody.
				int nDrop = hReq.GetLength() - nHeaderLen;
				if( nDrop > 0 )
					m_hReqBody.Add( p, nDrop);

				hReq.Clear();

				//-------------------------------------------------------------
				// Safety check of header block
				// Header's length must under HEADER_LINE_MAX
				//-------------------------------------------------------------
				pReq = (char*)(const char*)m_hReqHead;
	
				for( int count = 0; *pReq; pReq++, count++ )
				{
					if( count > HEADER_LINE_MAX )
						return 400;	// Bad Request

					if( *pReq == '\r' )
					{
						count = 0;

						if( pReq[1] == '\0' )
							return 400;		// Bad Request
						
						pReq += 2;
						continue;
					}
				}

				// Parse request line.
				int ret;
				ret = WorkParseRequestLine((const char*)m_hReqHead);
				if( ret != 200 ) return ret;

				// Parse request header
				ret = WorkParseRequestHeader((const char*)m_hReqHead);
				if( ret != 200 ) return ret;

				// HTTP/1.1 must need Host: header
				// @RFC2616 sec.19.6.1.1
				if( !strcmp( m_hrHttpReq.szHttpVer, "HTTP/1.1" ) &&
					!m_hashReqHeader.GetValueI("host") )
					return 400;	// Bad Request

				break;
			}
		}
		else // timeout
		{
		}


		// timeout check.
		DWORD dwSlipTime = (GetTickCount() - dwStartTime);
		
		// max 90sec. 47 days problem.
		if(	dwSlipTime > m_dwRecvTimeOut || dwSlipTime > 90000 )
		{
			//m_bKeepAlive = FALSE;
			return 0; // Time-out
		}

		// Check stop the keep-alive.
		if( hReq.GetLength() == 0 && *pbClose )
		{
			return 0; // Time-out
		}
	}	// end of while


	//-------------------------------------------
	// Make file path for windows system
	//-------------------------------------------
	int status = WorkMakePath(m_hrHttpReq.szFilePath, MAX_PATH);

	// ------------------------------------------
	// HTTP command process
	// ------------------------------------------

	// --------------------------------
	// GET
	// --------------------------------
	if( m_hrHttpReq.HttpCmd == HTTPGET )
	{
		//-------------------------------------------
		// If-Modified-Since:
		// @RFC2616 sec.14.25 If-Modified-Since
		//-------------------------------------------
		if( status == 200 )
		{
			pReq = m_hashReqHeader.GetValueI("if-modified-since");
			if( pReq != NULL )
			{
				if( MyTime( pReq ) >= MyTime((m_hrHttpReq.wfdFile.ftLastWriteTime)) )
				{
					return 304;
				}
			}
		}
		return status;
	}
	// --------------------------------
	// POST
	// --------------------------------
	else if( m_hrHttpReq.HttpCmd == HTTPPOST )
	{
		char* p = m_hashReqHeader.GetValueI("content-length");
		
		if( p == NULL )
			return 411; // Length Required

		long lTotalSize = m_hReqBody.GetLength();
		long lContentLength = atol(p);

		if( lContentLength < 0 )
			return 400;	// Bad Request

		nRecvLen = 0;

		while(1)
		{
			// size check.
			lTotalSize += nRecvLen;

			if( lTotalSize >= lContentLength )
				return status;

			nRecvLen = RecvData(szHeadBuf, SOCKET_HEAD_BUF);

			// Socket error
			if( nRecvLen == SOCKET_ERROR )
			{
				m_hReqBody.Clear();
				return 0;
			}
			
			// Time out
			else if( nRecvLen == 0 )
			{
			}

			if( 0 == m_hReqBody.Add((void*)szHeadBuf, nRecvLen) )
			{
				m_hReqBody.Clear();
				return 413; // Request Entity Too Large
			}

			// timeout check.
			if( GetTickCount() - dwStartTime > m_dwRecvTimeOut )
			{
				m_hReqBody.Clear();
				return 0; // Time-out
			}

		}
		return status;
	}
	else
	{
		return status;
	}
}

//-----------------------------------------------------------------------------
//	@detail
//		Main response function
//	@param
//		nHttpStatus		Result of http status
//		int bClose		Keep-Alive flag
//								default is 0
//	@return
//		0 indicate socket error.
//		other indicate http status.
//-----------------------------------------------------------------------------
int MyHttpSock::SendResponse(int nHttpStatus, int bClose)
{
	int	nSockStatus = 0;

	// According to http status, send default message.

	// ====================================================================
	// BASIC AUTH
	// ====================================================================
	nHttpStatus = CheckBasicAuth( nHttpStatus, m_hrHttpReq.szFilePath, m_pServerInfo->pszAccessFileName );
	
	switch( nHttpStatus )
	{

		// ----------------------------------
		// ERROR
		// ----------------------------------
		case 0:
			return 0;

		// ====================================================================
		// 200 OK
		// ====================================================================
		case 200:
		{
			WCHAR	wszFile[MAX_PATH];
			WorkMakeEnv();

			char szHeadBuf[SOCKET_HEAD_BUF];
			char szBodyBuf[SOCKET_BODY_BUF];

			char* pszFPath = m_hrHttpReq.szFilePath;
			int nFileNameLen = strlen( m_hrHttpReq.szFilePath );
			char* pszExtend = &m_hrHttpReq.szFilePath[nFileNameLen-1];

			// Check extend word
			while( *pszExtend != '\\' && *pszExtend != '.' )
			{
				pszExtend--;
			}

			// Check mime type
			char* pszMimeType = g_ctMime.GetMimeType(pszExtend);

			// if the first word is \ then that is server page.
			if( *pszMimeType == '\\' ) 
			{
				WorkMakeEnv();
				// --------------------------
				// SCRIPT_NAME
				// --------------------------
				int nDRootLen = strlen( m_pServerInfo->pszDocRootName );
				m_hashEnv.Set( "SCRIPT_NAME", &pszFPath[nDRootLen] );
				bslash2slash( m_hashEnv.GetValue("SCRIPT_NAME") );

				return ExecuteChx( pszMimeType, bClose );
			}

			// trancelate filename to unicode
			if( 0 == MultiByteToWideChar(CP_ACP, 0, pszFPath, -1, wszFile, MAX_PATH) )
			{
				return SendDefaultHttpResponse(500, bClose, __LINE__);
			}

			// ------------------------------
			// HTTP/1.x OK xxxx
			// Server: xxxxx
			// Content-Length: xxxx
			// Last-Modified: Mon, 24 Sep 2001 15:20:34 GMT
			// Content-Type: xxxx/xxxx
			// ------------------------------

			sprintf(szHeadBuf, 
				"%s %s\r\n"
				"Server: %s\r\n"
				"Content-Length: %u\r\n"
				"Last-Modified: %s\r\n"
				"Connection: %s\r\n"
				"Content-Type: %s\r\n\r\n"
				
				, m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_200].pszString
				, m_pServerInfo->pszSoftware
				, m_hrHttpReq.wfdFile.nFileSizeLow
				, m_hrHttpReq.szFileTime
				, (bClose ? STR_CLOSE : STR_KEEP_ALIVE)
				, pszMimeType
			);

			if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;
			
			// ------------------------------
			// Send file
			// ------------------------------

			DWORD	dwReadBytes;

			// HEAD command doesn't send file
			if( m_hrHttpReq.HttpCmd == HTTPGET )
			{
				// Take file size for log. uh,
				sprintf( szBodyBuf, "%d", m_hrHttpReq.wfdFile.nFileSizeLow );
				m_hashReqHeader.Set( LOG_SEND_DATA, szBodyBuf );

				// file open
				HANDLE hFile = CreateFile(
					wszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);

				if( hFile == INVALID_HANDLE_VALUE )
				{
					return SendDefaultHttpResponse(500, bClose, __LINE__);
				}

				do
				{
					// A file is divided and transmitted.
					if( ReadFile( hFile, szBodyBuf, SOCKET_BODY_BUF, &dwReadBytes, NULL ) )
					{
						if( dwReadBytes == 0 )
						{
							break;
						}

						nSockStatus = SendData(szBodyBuf, dwReadBytes);
						if( nSockStatus < 1 )
						{
							CloseHandle( hFile );
							return 0;
						}
					}
					else
					{
						break;
					}
				}while( dwReadBytes > 0 );

				CloseHandle( hFile );
			}
			break;
		}

		// ====================================================================
		// 302 Object Moved.
		// ====================================================================
		case 302:
		{
			char szHeadBuf[512];
			char szBodyBuf[512];

			char* p = m_hrHttpReq.szFilePath;
			bslash2slash(p);
			// ------------------------------
			// Object may be here. xxxx
			// ------------------------------
			sprintf(szBodyBuf, 
				"<html><body><a href=\"%s\">Object moved.</a><address>%s</address></body></html>"
				, m_hrHttpReq.szFilePath, m_pServerInfo->pszSoftware );

			// ------------------------------
			// HTTP/1.x 302 xxxx
			// Server: xxxxx
			// Location: xxxx
			// Content-Length: nnnn
			// Connection: Close/Keep-Alive
			// ------------------------------
			sprintf(szHeadBuf, 
				"%s %s\r\n"
				"Server: %s\r\n"
				"Location: %s\r\n"
				"Content-Length: %u\r\n"
				"Connection: %s\r\n"
				"Content-Type: text/html\r\n"
				"\r\n"
				
				, m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_302].pszString
				, (char*)m_pServerInfo->pszSoftware
				, m_hrHttpReq.szFilePath
				, strlen(szBodyBuf)
				, (bClose ? STR_CLOSE : STR_KEEP_ALIVE)
			);
			
			if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;
			if( (nSockStatus = SendData(szBodyBuf) < 1)) return 0;
			break;
		}

		// ====================================================================
		// 401 Access Denied
		// ====================================================================
		case 401:
		{
			char szHeadBuf[512];
			char szBodyBuf[512];

			// ----------------------------------
			// HTTP/1.1 401 Access Denied
			// Server: xxxxx
			// WWW-Authenticate: Basic realm="xxxx"
			// Content-Length: nnnn
			// Content-Type: text/html
			// ----------------------------------
			char* pszHost;
			pszHost = ( m_hashReqHeader.GetValueI("host") );
			if( !pszHost )
				pszHost = "localhost";

			sprintf(szHeadBuf, 
				"%s %s\r\n"
				"Server: %s\r\n"
				"WWW-Authenticate: Basic realm=\"%s%s\"\r\n"
				"Connection: close\r\n"
				"Content-Type: text/html\r\n"
				"Content-Length: %u\r\n"
				"\r\n"
				"%s"
				
				,m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_401].pszString
				,(char*)m_pServerInfo->pszSoftware
				,  pszHost, m_hrHttpReq.szUrlPath

				, strlen(hsStatus[HTTPSTATUS_401].pszString)
				, hsStatus[HTTPSTATUS_401].pszString
			);
			
			if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;
			if( (nSockStatus = SendData(szBodyBuf) < 1)) return 0;
			break;
		}

		// ====================================================================
		// 999 CehttpGatewayInterface
		// ====================================================================
		case 999:
		{
			WorkMakeEnv();
			char* pszFPath = m_hrHttpReq.szFilePath;
			int nFPathLen = strlen(pszFPath);
			
			// --------------------------
			// SCRIPT_NAME
			// --------------------------
			int nDRootLen = strlen(m_pServerInfo->pszDocRootName);
			m_hashEnv.Set("SCRIPT_NAME", &pszFPath[nDRootLen]);
			bslash2slash(m_hashEnv.GetValue("SCRIPT_NAME"));

			// ----------------------------------------------------------------
			// CHX̌Ăяo
			// ----------------------------------------------------------------
			if( 0 == my_strnicmp( &pszFPath[nFPathLen] - 4, ".chx", 4 ) )
			{
				return ExecuteChx( pszFPath, bClose );
			}
			// ----------------------------------------------------------------
			// DLLĂяo̔
			// ----------------------------------------------------------------
			else if( 0 == my_strnicmp( &pszFPath[nFPathLen] - 4, ".dll", 4 ) )
			{
				return ExecuteDll( pszFPath, bClose );
			}
			// ----------------------------------------------------------------
			// CGI Ăяo̔
			// ----------------------------------------------------------------
			else if( 0 == my_strnicmp( &pszFPath[nFPathLen] - 4, ".exe", 4 ) )
			{
				return ExecuteCGI( pszFPath, bClose );
			}
			// ----------------------------------------------------------------
			// ̑
			// ----------------------------------------------------------------
			else
			{
				//403 Access Forbidden
				return SendDefaultHttpResponse(403, bClose, __LINE__);
			}
			break;
		}

		default:
		{
			return SendDefaultHttpResponse(nHttpStatus, bClose);
		}
	}

	if( nSockStatus < 1 )
	{
		return 0;
	}
	return nHttpStatus;
}

//-----------------------------------------------------------------------------
//	@detail
//		HTTP STATUSɏ]ĕԓԂ
//	@param
//		nHttpStatus		ԓ
//		int bClose	߂ɒʐM؂グtO
//								ftHg1łB
//	@return
//		M
//		0 SOCKET_ERROR
//	@RFC2616
//-----------------------------------------------------------------------------
int MyHttpSock::SendDefaultHttpResponse(int nHttpStatus, int bClose, int nAddtionalInfo/*=0*/)
{
	char szHeadBuf[512];
	
	char* pszErrorMsgHtml = NULL;
	int ii = 0;
	int nSockStatus = 0;

	// G[ԍTAuEU֕ԓ
	while(hsStatus[ii].nStatus != 0)
	{
		if( hsStatus[ii].nStatus == nHttpStatus )
		{
			pszErrorMsgHtml = (char*)hsStatus[ii].pszString;

			sprintf(szHeadBuf,
				"%s %s\r\n"
				"Server: %s\r\n"
				"Connection: %s\r\n"		// @RFC2616 sec.14.9
				"Content-Length: %u\r\n"
				"Content-Type: text/html\r\n"
				"\r\n"
				"%s(%010d)"

				,m_hrHttpReq.szHttpVer, hsStatus[ii].pszString
				, m_pServerInfo->pszSoftware
				, (bClose ? STR_CLOSE : STR_KEEP_ALIVE)
				, strlen(pszErrorMsgHtml)+12
				, pszErrorMsgHtml
				, nAddtionalInfo
				);

			nSockStatus = SendData(szHeadBuf);
			if( nSockStatus < 1 )
			{
				return 0;
			}
			break;
		}
		ii++;
	}
	return nHttpStatus;

}

//-----------------------------------------------------------------------------
//	@detail
//		Do check basic authentication
//	@param
//		nHttpStatus		HTTP status
//		pszFilePath		Authentication file's path
//		pszBAuthFile	Authentication file
//	@return
//		nHttpSatus	Read success
//		401			Need authentication.
//		403			Authentication failed.
//		500			InternalServerError
//	http://www.ietf.org/rfc/rfc2617.txt
//  RFC 2617
//-----------------------------------------------------------------------------
// WWW-Authenticate: Basic realm="localhost"
// HTTP/1.1 401 Access Denied
//-----------------------------------------------------------------------------
int MyHttpSock::CheckBasicAuth(int nHttpStatus, const char *pszFilePath, const char *pszBAuthFile)
{
	char	szFile[MAX_PATH];	// tmp
	char*	pszSerchPath;
	char*	p;
	int		nLen;
	int		nDocRootLen;
	int		nAuthFileLen;
	HANDLE hFile;
	WIN32_FIND_DATA FindFileData;

	// Initialize
	memset( szFile, 0, MAX_PATH );
	nDocRootLen = strlen( m_pServerInfo->pszDocRootName );
	nAuthFileLen = strlen( pszBAuthFile );
	pszSerchPath = my_strdup( pszFilePath );

	if( pszSerchPath == NULL )
		return 500;

	// access.cha?
	nLen = strlen( pszSerchPath );
	p = &pszSerchPath[nLen];
	while( *p != '\\' && p != pszSerchPath ) p--;
	p++;
	
	if( 0 == my_stricmp( pszBAuthFile, p ) )
		return 404;



	do
	{
		// Back pointer to end of \.
		// \aaa\bbb\ccc.ddd -> \aaa\bbb
		nLen = strlen( pszSerchPath );
		p = &pszSerchPath[nLen];
		while( *p != '\\' && p != pszSerchPath ) p--;
		*p = '\0';

		if( (nLen = strlen( pszSerchPath )) < nDocRootLen )
			break;

		// Serch path arrived to root
		if( pszSerchPath[0] == '\0' )
			break;

		strcpy( szFile, pszSerchPath );
		strcat( szFile, "\\" );
		strcat( szFile, pszBAuthFile );

		hFile = FindFirstFileMBCS( szFile, &FindFileData );

		if( hFile == INVALID_HANDLE_VALUE )
		{
			continue;
		}
		else
		{
			if( FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
				continue;

			FindClose( hFile );
			free( pszSerchPath );
			return CheckBasicAuthFile(nHttpStatus, szFile);
			break;

		}

	}while( 1 );

	free( pszSerchPath );
	return nHttpStatus;
}

//-----------------------------------------------------------------------------
//	@detail
//		Read authentication file to memory.
//		work under CheckBasicAuth
//	@param
//		
//	@return
//		nHttpSatus	Read success
//		401			Need authentication.
//		403			Authentication failed.
//		500			InternalServerError
//	@comment
//		Sequence of retry is automaticaly processed by blowser,
//		then I return 401 always.
//-----------------------------------------------------------------------------
// GET / HTTP/1.0
// Authorization: Basic aXNoaTo=
// User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)
// Host: localhost
// Connection: close
//-----------------------------------------------------------------------------
int MyHttpSock::CheckBasicAuthFile(int nHttpStatus, char* pszAuthFilePath)
{
	// --------------------------------------------------------------
	// Request header check.
	// --------------------------------------------------------------
	char* p = m_hashReqHeader.GetValueI("authorization");
	char szUserName[64] = {'\0'};

	if( p == NULL )
		return 401; // Access Denied

	if( my_strnicmp(p, "basic", 5) != 0 )
		return 401;

	p += 5;
	while( *p == ' ' ) p++;

	// base64 decording.
	p = strncpy(szUserName, p, 63);
	
	Base64Decord((unsigned char*)p);

	// --------------------------------------------------------------
	// passwd file open
	// --------------------------------------------------------------
	int	nFile = strlen(pszAuthFilePath);
	WCHAR*	pwszFile = new WCHAR[nFile+1];

	if( pwszFile == NULL )
	{
		// 500 InternalServerError
		return 500;
	}
	memset( pwszFile, 0, sizeof(WCHAR)*(nFile+1) );
	
	if( 0 == MultiByteToWideChar(CP_ACP,0,pszAuthFilePath,-1,pwszFile, nFile+1) )
	{
		delete[] pwszFile;
		// 500 InternalServerError
		return 500;
	}

	// --------------------------------------------------------------
	HANDLE hFile = CreateFile(pwszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	delete[] pwszFile;
	MyVarMem	vm;

	if( hFile == INVALID_HANDLE_VALUE )
	{
		return 500;	// Internal Server Error
	}
	else
	{
		char	szBuf[256];
		BOOL	bResult;
		DWORD	dwReadBytes;
		do
		{
			bResult = ReadFile( hFile, szBuf, 510, &dwReadBytes, NULL );
			
			if(dwReadBytes == 0)
				break;

			vm.Add( szBuf, dwReadBytes );

		}while( bResult );

		CloseHandle(hFile);
	}

	// Do nothing if file length is 0.
	if( vm.GetLength() == 0 )
	{
		return nHttpStatus;
	}

	// --------------------------------------------------------------
	// user:password check.
	// --------------------------------------------------------------
	char*	pPasswd;
	char*	pNextPasswd;

	pPasswd = pNextPasswd = (char*)vm.GetBuffer();

	do
	{
		while( *pNextPasswd == '\r' ||  *pNextPasswd == '\n' )
			pNextPasswd++;

		if( *pNextPasswd == '\0' )
			return 401;//403;

		pPasswd = pNextPasswd;

		while( *pNextPasswd != '\r' &&  *pNextPasswd != '\n' && *pNextPasswd != '\0' )
		{
			pNextPasswd++;
		}
		if( *pNextPasswd != '\0' )
			*pNextPasswd++ = '\0';
		
		if( strcmp( pPasswd, p ) == 0 )
		{	
			// Authentication success.
			// make user name for access_log.
			char szUserName[16];
			for( int ii = 0; (ii < 15) && (*pPasswd != ':') && (*pPasswd != '\0'); ii++, pPasswd++ )
			{
				szUserName[ii] = *pPasswd;
			}
			szUserName[ii] = '\0';
			m_hashReqHeader.Set("authentication_user", szUserName);
			return nHttpStatus;
		}

		// next line
	}while( *pNextPasswd != '\0' );

	return 401;//403;

}


//-----------------------------------------------------------------------------
//	@detail
//		Do parse request line
//	@param
//		
//	@return
//		400 sȃNGXg
//		200 I
//		500 InternalServerError
//		501 not implement
//
//	RFC2616 sec.5.1
//		Request-Line   = Method SP Request-URI SP HTTP-Version CRLF
//-----------------------------------------------------------------------------
int MyHttpSock::WorkParseRequestLine(const char* pSrc)
{
	char szTmp1[HEADER_LINE_MAX]
		,szTmp2[HEADER_LINE_MAX]
		,szTmp3[HEADER_LINE_MAX];

	//-------------------------------------------
	// NGXgC擾Am_hashReqHeaderɓ
	//-------------------------------------------
	
	const char* ps = pSrc;
	char* pd = szTmp1;
	while( *ps != '\r' && *ps != '\n' && *ps != '\0' )
	{
		*pd++ = *ps++;
	}
	*pd = '\0';

	m_hashReqHeader.Set( LOG_REQUEST_LINE, szTmp1);


	//-------------------------------------------
	// NGXgC̉
	//-------------------------------------------
	char* pReq = (char*)pSrc;
	
	//if( 3 != sscanf( pReq, "%s%s%s",szTmp1, szTmp2, szTmp3 ) )
	if( 3 > ParseRequestLine(pReq, szTmp1, szTmp2, szTmp3) )
		return 400;	// Bad Request


	// R}h̏Ɖ
	if( !strcmp( szTmp1, "GET" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPGET;
	}
	else if( !strcmp( szTmp1, "HEAD" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPHEAD;
	}
	else if( !strcmp( szTmp1, "POST" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPPOST;
	}
	else if( 
		!strcmp( szTmp1, "PUT" )	||
		!strcmp( szTmp1, "DELETE" )	||
		!strcmp( szTmp1, "TRACE" )	||
		!strcmp( szTmp1, "OPTIONS" )||
		!strcmp( szTmp1, "CONNECT" )||
		!strcmp( szTmp1, "LINK" )	||
		!strcmp( szTmp1, "UNLINK" )	)
	{
		m_hrHttpReq.HttpCmd = HTTPNOTIMPLEMENTED;
		return 501;	// Not Implemented
	}
	else
	{
		m_hrHttpReq.HttpCmd = HTTPUNKNOWN;
		return 400;	// Bad Request
	}


	//-------------------------------------------
	// HTTPversion̉
	//-------------------------------------------
	if( !strcmp( szTmp3, "HTTP/1.0" ) || !strcmp( szTmp3, "HTTP/1.1" ) )
	{
		strcpy(m_hrHttpReq.szHttpVer, szTmp3);
	}
	else
	{
		// sȃo[W̏ꍇAԓHTTP/1.0ɂ
		strcpy(m_hrHttpReq.szHttpVer, "HTTP/1.0");
		return 400;	// Bad Request
	}

	//-------------------------------------------
	// pX̉
	//-------------------------------------------
	char* pszPathFrom = szTmp2;
	char* pszUrlPath	= m_hrHttpReq.szUrlPath;
	char* pszPathTo = m_hrHttpReq.szFilePath;

	// URIhttp://servername/..../̃p^[̏ꍇ
	// @RFC2616 sec.5.1.2 absoluteURI
	// Host͐Ɖ肷B
	// ԈĂvNVB
	if( !strncmp( pszPathFrom, "http://", 7 ) )
	{
		// http://servername:80/path/
		pszPathFrom += 7;
		// -> servername:80/path/
		
		if( NULL == (pszPathFrom = strstr(pszPathFrom, "/")) )
		{
			return 400;	// Bad Request
		}

		if( *pszPathFrom != '/' )
		{
			return 400;	// Bad Request
		}
		// -> /path/
	}

	// '/'  '\' ɕϊȂRs[
	// ?\0ŃRs[I
	while( *pszPathFrom != '\0' && *pszPathFrom != '?')
	{
		*pszUrlPath = *pszPathFrom;

		if( *pszPathFrom == '/' )
		{
			*pszPathTo = '\\';
		}
		else
		{
			*pszPathTo = *pszPathFrom;
		}
		
		pszPathFrom++;
		pszPathTo++;
		pszUrlPath++;
	}
	*pszPathTo = '\0';
	*pszUrlPath = '\0';

	// ------------------------------------------
	// ?ȍ~̓p[^Ƃm_hashReqHeadɊi[
	// ------------------------------------------
	if( *pszPathFrom == '?' )
	{
		pszPathFrom++;

		m_hashReqHeader.Set("QUERY_STRING", pszPathFrom);

		char* pParam = pszPathFrom;
		char* pKey;
		char* pValue;

		while( *pParam != '\0' )
		{
			pKey = szTmp1;
			pValue = szTmp2;

			// Get key
			while( *pParam != '\0' && *pParam != '=' && *pParam != '&' )
			{
				*pKey = *pParam;
				*pKey++;
				*pParam++;
			}
			*++pKey = '\0';
			*pParam++;
			// GetValue
			while( *pParam != '\0' && *pParam != '=' && *pParam != '&' )
			{
				*pValue = *pParam;
				*pValue++;
				*pParam++;
			}
			*++pValue = '\0';
			*pParam++;

			if( !m_hashReqHeader.Set(szTmp1, szTmp2) ||
				m_hashReqHeader.GetLength() > 4000)
			return 500;

		}
	}


	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		Dp parse request line
//	@param
//		pReq		Request data from browser.
//		szCmd		[out]HEAD,GET,POST, ...
//		szPath		[out]Request file
//		szHttpVer	[out]HTTP version
//	@return
//		The number of the acquired data.
//-----------------------------------------------------------------------------
int MyHttpSock::ParseRequestLine( const char* pReq, char* szCmd, char* szPath, char* szHttpVer )
{
	// Method SP Request-URI SP HTTP-Version CRLF
	// pReq ͕K'\r\n'܂ł
	//szCmd̃obt@͕ۏ؂Ȃ̂ŁAĂяoŒ̂
	
	if( pReq == NULL || *pReq == '\0' )
		return 0;

	// szCmd
	while( *pReq != ' ' && *pReq != '\t' )
	{
		if( *pReq == '\0' || *pReq == '\r' || *pReq == '\n' )
		{
			*szCmd = '\0';
			return 1;
		}
		*szCmd++ = *pReq++;
	}
	*szCmd = '\0';
	pReq++;

	// szPath
	while( *pReq != ' ' && *pReq != '\t' )
	{
		if( *pReq == '\0' || *pReq == '\r' || *pReq == '\n' )
		{
			// HTTP verȗꂽꍇAHTTP/1.0Ƃď
			*szPath = '\0';
			strcpy(szHttpVer, "HTTP/1.0");
			return 3;
		}
		*szPath++ = *pReq++;
	}
	*szPath = '\0';
	pReq++;

	// szHttpVer
	while( *pReq != '\0' && *pReq != '\r' && *pReq != '\n' )
	{
		*szHttpVer++ = *pReq++;
	}
	*szHttpVer = '\0';
	return 3;

}


//-----------------------------------------------------------------------------
//	@detail
//		The request header string is dvided and put it into m_hashReqHeader
//	@param
//		pSrc	Request data from browser.
//	@return
//		400 Bad request
//		200 OK
//		500 InternalServerError
//
//	@RFC2616 sec.5
//-----------------------------------------------------------------------------
int MyHttpSock::WorkParseRequestHeader(const char* pSrc)
{
	//-------------------------------------------
	// NGXgwb_tB[h̉
	//-------------------------------------------
	char szReqKey[HEADER_LINE_MAX], szReqValue[HEADER_LINE_MAX];

	char* pReq = (char*)pSrc;
	// NGXgC(GET /index.html HTTP/1.0 ...)̎̍s
	if( NULL == ( pReq = strstr( pReq, "\r\n" )) )
	{
		return 400;	// Bad Request
	}
	pReq += 2;
	
	while( *pReq != '\0' )
	{
		if( *pReq == '\r' )	// end of request header
			break;
		
		if( 2 == ParseRequestHeader( (const char*)pReq, szReqKey, szReqValue ) )
		{
			// Request header must under 4000 bytes
			if( !m_hashReqHeader.Set(szReqKey, szReqValue) ||
				m_hashReqHeader.GetLength() > 4000)
			return 500;
		}

		if( NULL == (pReq = strstr( pReq, "\r\n" )) )
			return 400;	// Bad Request

		pReq += 2;
	}
	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		NGXgwb_[Fŕ
//	@param
//	@return
//		擾łZeX̐
//-----------------------------------------------------------------------------
int MyHttpSock::ParseRequestHeader( const char* pReq, char* szReqKey, char* szReqValue )
{
	if( pReq == NULL || *pReq == '\0' )
		return 0;

	// --------------------------------------------------------------
	// uFv܂łRs[B󔒂͖
	// --------------------------------------------------------------
	*szReqKey = *pReq;
	while( *pReq != ':' )
	{
		if( *pReq == ' ' || *pReq == '\t' )
		{
			*pReq++;
			continue;
		}
		else if( *pReq == '\r' || *pReq == '\n' || *pReq == '\0' )
		{
			*szReqKey = '\0';
			return 1;
		}
		*szReqKey = *pReq;
		szReqKey++;
		pReq++;
	}
	pReq++;
	*szReqKey = '\0';
	// --------------------------------------------------------------
	// uFvȍ~Rs[B̋󔒂͖
	// --------------------------------------------------------------
	while( *pReq == ' ' || *pReq == '\t' ) pReq++;

	while( *pReq != '\0' && *pReq != '\r'  && *pReq != '\n')
	{
		*szReqValue++ = *pReq++;
	}
	*szReqValue = '\0';
	return 2;
}

//-----------------------------------------------------------------------------
//	@detail
//		t@CpX
//		CGIǂ̔RRōs
//		̎dlɂCGI[gDoc[gzɂ邱ƂKvƂȂ
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔FȂ
//
//	@param
//		char*	pszSrc			/->\ɏꂽt@C
//								tpXɏ܂B
//								\xxx.html -> \<docroot>\xxx.html
//		int		nBufferSize		MAX_PATHoCgł邱ƂKvłB
//	@return
//		999
//		400
//		302
//		200
//	@out
//		m_hrHttpReq.wfdFile
//		m_hrHttpReq.szFileTime
//		pszSrc					
//-----------------------------------------------------------------------------
int MyHttpSock::WorkMakePath(char* pszSrc, int nBufferSize)
{
	//char szTmpSrc[MAX_PATH];
	int	bIsCgi = FALSE;
	char* p = pszSrc;

	char szFullPath[MAX_PATH];		// Ɨpobt@
	int	nFullPathLen;				// Ɨpobt@
	int nDRootLen = strlen(m_pServerInfo->pszDocRootName);
	int nCRootLen = strlen(m_pServerInfo->pszCgiRootName);
	int nSrcLen = strlen(pszSrc);

	memset( &m_hrHttpReq.wfdFile, 0, sizeof(WIN32_FIND_DATA) );

	// ȒPȃTCY`FbN
	if( nDRootLen + nSrcLen + 12/*\index.html|\0|*/ > nBufferSize )
		return 400;	// Bad Request

	// ------------------------------------------
	// Access check for directory
	// ------------------------------------------
	int count = 0;

	do{
		// \x	+1
		// \.	 0
		// ..	-1

		if( p[0] == '\\' && p[1] != '.' )
			count++;
		else if( p[0] == '.' && p[1] == '.' )
			count--;

		if( count < 1 )
			return 400;	// Bad Request

	}while( *++p != '\0' );

	// ------------------------------------------
	// Join document root and path
	// ------------------------------------------
	szFullPath[0] = '\0';

	strcat( szFullPath, m_pServerInfo->pszDocRootName );
	strcat( szFullPath, pszSrc );

	nFullPathLen = strlen(szFullPath);

	// ------------------------------------------
	// CGIǂ̔
	// t@CpX̐擪CGI[gƓȂ
	// ------------------------------------------
	if( 0 == strncmp( szFullPath, m_pServerInfo->pszCgiRootName, 
									strlen(m_pServerInfo->pszCgiRootName) ) )
	{
		m_hashEnv.Set("PATH_INFO",	"");
		m_hashEnv.Set("PATH_TRANSLATED", m_pServerInfo->pszDocRootName);
		bIsCgi = TRUE;
	}

	// ------------------------------------------
	// If last word is \, it must believe that I add a default page strings.
	// ------------------------------------------
	if( szFullPath[nFullPathLen-1] == '\\' )
	{
		if( !bIsCgi )
		{
			// mɃfBNgw肵Ă
			strcat( szFullPath, m_pServerInfo->pszDefaultDocName );
		}
	}

	// ------------------------------------------
	// unicode conversion
	// ------------------------------------------
	// t@Č
	HANDLE hFFF = FindFirstFileMBCS(szFullPath, &m_hrHttpReq.wfdFile );

	if( INVALID_HANDLE_VALUE != hFFF )
	{
		// t@C𔭌
		FindClose(hFFF);

		// fBNg̏ꍇ͍Ō\index.htmltĕԂ
		if( m_hrHttpReq.wfdFile.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
		{
			// HTTP/1.1 302 Object Moved
			strcat( pszSrc, "\\" );
			strcat( pszSrc, m_pServerInfo->pszDefaultDocName );
			return 302;		//Object Moved.
		}
	}
	// ------------------------------------------
	// Work for PATH_INFO
	// ------------------------------------------
	else
	{
		// http://<server name>/<cgi root>/.../xxx.cgi/....
		//                                            ^this is path info.
		if( bIsCgi )
		{
			char* pTmp = &szFullPath[nCRootLen+1];
			// <cgi_path>\sample.cgi\path1\path2\path3
			//            ^-p
			// /܂őOi
			for( ;*pTmp != '\\' && *pTmp != '\0'; pTmp++ );
			// \<cgi_path>\sample.cgi\path1\path2\path3
			//             ^-p

			while(1)
			{
				if( *pTmp == '\0' )
				{
					return 404;	// "Object Not Found"
				}
				
				*pTmp = '\0';

				hFFF = FindFirstFileMBCS(szFullPath, &m_hrHttpReq.wfdFile );

				// t@C݂ꍇ
				if(
					( INVALID_HANDLE_VALUE != hFFF )
					&& !( m_hrHttpReq.wfdFile.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ))
				{
					// CGIĂԎm肵߂hashEnvɒl
					FindClose(hFFF);

					// PATH_INFO̐擪\t邽߂
					*pTmp = '\\';

					// --------------------------
					// PATH_INFO
					// --------------------------
					// UnEscape(pTmp);
					m_hashEnv.Set("PATH_INFO",	pTmp);
					bslash2slash(m_hashEnv.GetValue("PATH_INFO"));

					// --------------------------
					// PATH_TRANSLATED
					// --------------------------
					char	path_trans[MAX_PATH];

					if( nDRootLen + strlen( pTmp ) >= MAX_PATH -1 )
						return 400;
					
					strcpy( path_trans, m_pServerInfo->pszDocRootName );
					strcat( path_trans, pTmp );
					// UnEscape( path_trans );
					m_hashEnv.Set("PATH_TRANSLATED",	path_trans);
					slash2bslash(m_hashEnv.GetValue("PATH_TRANSLATED"));


					// Separete PATH_INFO again
					*pTmp = '\0';

					break;
				}
				*pTmp++ = '\\';

				// next
				for( ;*pTmp != '\\' && *pTmp != '\0'; pTmp++ );

			}			
		}
		else
		{
			return 404;	// "Object Not Found"
		}
	}
	strncpy( pszSrc, szFullPath, nBufferSize );

	// ------------------------------------------
	// If CGI return special result 999
	// ------------------------------------------
	if(bIsCgi)
	{
		/*
		// --------------------------
		// SCRIPT_NAME
		// --------------------------
		m_hashEnv.Set("SCRIPT_NAME", &szFullPath[nDRootLen]);
		bslash2slash(m_hashEnv.GetValue("SCRIPT_NAME"));
		*/

		return 999;	// CGI
	}

	// Write time to m_hrHttpReq.szFileTime
	MyTime time(m_hrHttpReq.wfdFile.ftLastWriteTime);
	strcpy(m_hrHttpReq.szFileTime, time.GetFormatRfc1123());
	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		Make Environment variable.
//	@param
//	@return
//-----------------------------------------------------------------------------
void MyHttpSock::WorkMakeEnv()
{
	char work[MAX_PATH];
	
	// ------------------------------------------------------------------------
	// CONTENT_XXX
	// ------------------------------------------------------------------------
	sprintf(work, "%u", m_hReqBody.GetLength());
	m_hashEnv.Set("CONTENT_LENGTH",		work);
	m_hashEnv.Set("CONTENT_TYPE",		m_hashReqHeader.GetValueI("content-type"));
	
	// ------------------------------------------------------------------------
	// QUERY_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("QUERY_STRING",		m_hashReqHeader.GetValue("QUERY_STRING"));
	
	// ------------------------------------------------------------------------
	// REMOTE_XXX
	// ------------------------------------------------------------------------
	sockaddr_in* psa = m_hrHttpReq.psaRemoteHost;
	u_char* p = (u_char*)&(psa->sin_addr.S_un.S_un_b);
	sprintf(work, "%u.%u.%u.%u", p[0], p[1], p[2], p[3]);
	m_hashEnv.Set("REMOTE_ADDR",		work);
	sprintf(work,"%d", psa->sin_port);
	m_hashEnv.Set("REMOTE_PORT",		work);
	// Since DNS resolve is slow, it was not supported
	//m_hashEnv.Set("REMOTE_HOST",		);
	
	// ------------------------------------------------------------------------
	// REQUEST_XXX
	// ------------------------------------------------------------------------
	switch(m_hrHttpReq.HttpCmd)
	{
		case HTTPHEAD:
			m_hashEnv.Set("REQUEST_METHOD",		"HEAD");
			break;
		case HTTPGET:
			m_hashEnv.Set("REQUEST_METHOD",		"GET");
			break;
		case HTTPPOST:
			m_hashEnv.Set("REQUEST_METHOD",		"POST");
			break;
		default:
			m_hashEnv.Set("REQUEST_METHOD",		"");
			break;
	}

	// ------------------------------------------------------------------------
	// SERVER_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("SERVER_NAME",		m_hashReqHeader.GetValueI("host"));
	sprintf(work, "%u",					m_pServerInfo->nPort);
	m_hashEnv.Set("SERVER_PORT",		work);
	m_hashEnv.Set("SERVER_PROTOCOL",	m_hrHttpReq.szHttpVer);
	m_hashEnv.Set("SERVER_SOFTWARE",	m_pServerInfo->pszSoftware);
	
	// ------------------------------------------------------------------------
	// HTTP_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("HTTP_ACCEPT",		m_hashReqHeader.GetValueI("accept"));
	m_hashEnv.Set("HTTP_USER_AGENT",	m_hashReqHeader.GetValueI("user-agent"));
	m_hashEnv.Set("HTTP_COOKIE",		m_hashReqHeader.GetValueI("cookie"));
	m_hashEnv.Set("HTTP_REFERER",		m_hashReqHeader.GetValueI("referer"));
	
	// ------------------------------------------------------------------------
	// DOCUMENT_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("DOCUMENT_ROOT",		m_pServerInfo->pszDocRootName);
}

//-----------------------------------------------------------------------------
//	@detail
//		Cleanup memory.
//	@param
//	@return
//-----------------------------------------------------------------------------
void MyHttpSock::FreeMemory()
{
	m_hReqHead.Clear();
	m_hReqBody.Clear();
	m_hashReqHeader.Clear();
	m_hashEnv.Clear();
}

//-----------------------------------------------------------------------------
//	@detail
//		Load specified chx file and execute.
//	@param
//		Full path of chx file.
//	@return
//-----------------------------------------------------------------------------
int MyHttpSock::ExecuteChx(char* pszFile, int bClose)
{
	// --------------------------
	// transform filename to unicode
	// --------------------------
	WCHAR	wszFile[MAX_PATH];

	if( 0 == MultiByteToWideChar(CP_ACP, 0, pszFile, -1, wszFile, MAX_PATH) )
	{
		return SendDefaultHttpResponse(500, bClose, __LINE__);
	}

	// --------------------------
	// execute
	// --------------------------
	char szHeadBuf[SOCKET_HEAD_BUF];

	m_hashEnv.Set("GATEWAY_INTERFACE",	"CHX/1.0");

	// --------------------------
	// Call CHX
	// --------------------------
	MyVarMem hRes;
	CEHTTP_CHX_EXTENTION pChx;

	HMODULE hDLL = ::LoadLibrary(wszFile);

	if( hDLL == NULL )
	{
		return SendDefaultHttpResponse( 500, bClose, __LINE__ );
	}

	pChx = (CEHTTP_CHX_EXTENTION)GetProcAddress( hDLL, FNC_EXTEND_CHX );

	if( !pChx )
	{
		FreeLibrary(hDLL);
		return SendDefaultHttpResponse( 500, bClose, __LINE__ );

	}
	
	m_hashEnv.SeekToFirst();

	int nCgiResponseLen = pChx( &m_hashEnv, &m_hReqBody, &hRes );

	// ------------------------------
	// Response has location header
	// ------------------------------
	char* phRes = (char*)hRes.GetBuffer();
	if( phRes == NULL )
	{
		return SendDefaultHttpResponse( 500, bClose, __LINE__ );
	}
	char* pRet = strstr( (const char*)phRes, "\r\n\r\n" );
	int nHeadlen;

	if( pRet != NULL )
	{
		nHeadlen = pRet - (const char*)hRes + 4;
	}
	else
	{
		hRes.Clear();
		FreeLibrary(hDLL);
		return SendDefaultHttpResponse( 500, bClose, __LINE__ );
	}

	// ------------------------------
	// wb_Location:𔭌ꍇ
	// Locationwb_Ĕ΂
	// Pȃ`FbNȂ̂Œ
	// ------------------------------
	if( my_strnicmp( hRes, "Location: " ,10) == 0 )
	{
		// ------------------------------
		// HTTP/1.x 302 Object Moved
		// Server: xxxxx
		// ------------------------------
		sprintf(szHeadBuf, 
			"%s %s\r\n"
			"Server: %s\r\n"
			"Connection: Close\r\n"

			, m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_302].pszString
			, m_pServerInfo->pszSoftware);
	}
	else
	{
		// ------------------------------
		// HTTP/1.x 200 OK
		// Server: xxxxx
		// ------------------------------
		sprintf(szHeadBuf, 
			"%s %s\r\n"
			"Server: %s\r\n"
			"Connection: Close\r\n"
			"Content-Length: %u\r\n"


			, m_hrHttpReq.szHttpVer, hsStatus[0].pszString
			, m_pServerInfo->pszSoftware
			, hRes.GetLength() - nHeadlen
			);
	}

	// ʏ̃wb_̑o
	if( (SendData(szHeadBuf) < 1)) return 0;

	// Take send len for log.
	sprintf( szHeadBuf, "%u", hRes.GetLength() - nHeadlen );
	m_hashReqHeader.Set( LOG_SEND_DATA, szHeadBuf );


	// ------------------------------
	// CHXf[^̑M
	// Content-Type: XXXX/XXXX
	// 
	// <data>
	// ------------------------------
	if( SendData( hRes, hRes.GetLength() + 1 ) < 1) return 0;
	hRes.Clear();
	FreeLibrary(hDLL);
	return 999;

}

//-----------------------------------------------------------------------------
//	@detail
//		Load specified dll file and execute.
//	@param
//		Full path of dll file.
//	@return
//-----------------------------------------------------------------------------
int MyHttpSock::ExecuteDll(char *pszFile, int bClose)
{
	// --------------------------
	// SCRIPT_NAME
	// --------------------------
	int nDRootLen = strlen(m_pServerInfo->pszDocRootName);
	m_hashEnv.Set("SCRIPT_NAME", &pszFile[nDRootLen]);
	bslash2slash(m_hashEnv.GetValue("SCRIPT_NAME"));

	// --------------------------
	// transform filename to unicode
	// --------------------------
	WCHAR	wszFile[MAX_PATH];

	if( 0 == MultiByteToWideChar(CP_ACP, 0, pszFile, -1, wszFile, MAX_PATH) )
	{
		return SendDefaultHttpResponse(500, bClose, __LINE__);
	}

	// --------------------------
	// Call DLL
	// --------------------------
	//int (*pCAPI)(const void*, int, const void*, int, const void*, int, void**);
	CEHTTP_DLL_EXTENTION pCAPI;

	HMODULE hDLL = ::LoadLibrary(wszFile);
	if( hDLL == NULL )
	{
		return SendDefaultHttpResponse(500, bClose, __LINE__);
	}

	pCAPI = (CEHTTP_DLL_EXTENTION)GetProcAddress(hDLL, FNC_EXTEND_DLL);

	if( !pCAPI )
	{
		FreeLibrary(hDLL);
		return SendDefaultHttpResponse( 500, bClose, __LINE__ );
	}

	void* pCgiResponse = NULL;

	int nCgiResponseLen = pCAPI(
		m_hashEnv.GetBuffer(), m_hashEnv.GetLength(),
		m_hReqHead.GetBuffer(), m_hReqHead.GetLength(),
		m_hReqBody.GetBuffer(), m_hReqBody.GetLength(),
		&pCgiResponse);

	if( NULL != pCgiResponse )
	{
		if( SendData((const char*)pCgiResponse, nCgiResponseLen) < 1)
		{
			FreeLibrary(hDLL);
			free(pCgiResponse);
			return 0;
		}
	}
	FreeLibrary(hDLL);
	
	return 999;
}

//-----------------------------------------------------------------------------
//	@detail
//		Load specified exe file and execute.
//	@param
//		Full path of dll file.
//	@return
//-----------------------------------------------------------------------------
int MyHttpSock::ExecuteCGI(char *pszFile, int bClose)
{
	return SendDefaultHttpResponse( 500, bClose, __LINE__ );
/*
	HANDLE hReadPipe;
	HANDLE hWritePipe;

	// CreatePIPE
	SECURITY_ATTRIBUTES sa;
	sa.nLength = sizeof( SECURITY_ATTRIBUTES );
	sa.bInheritHandle = TRUE;
	sa.lpSecurityDescriptor = NULL;

	if( 0 == CreatePipe( &hReadPipe, &hWritePipe, &sa, 4096 ) )
	{
		return SendDefaultHttpResponse( 500, bClose, __LINE__ );
	}
*/
/* real comment
	// Create Temp File
	WCHAR wszTempFileName[ MAX_PATH ];
	WCHAR wszTempPath[ MAX_PATH ];
	WCHAR pwszTempPath;
	HANDLE hPostFile = NULL;

	if( m_hrHttpReq.HttpCmd == HTTPPOST )
	{
		GetTempPath( MAX_PATH, wszTempPath );
	
		if( MAX_PATH == 0 )
			wcscpy( &pwszTempPath, L".");

		if( 0 == GetTempFileName( wszTempPath, L"TMP", 0, wszTempFileName ) )
		{
			CloseHandle( hReadPipe );
			CloseHandle( hWritePipe );
			return SendDefaultHttpResponse( 500, bClose, __LINE__ );
		}

		hPostFile = CreateFile(
						wszTempFileName
						, GENERIC_READ | GENERIC_WRITE
						, FILE_SHARE_READ
						, &sa
						, CREATE_ALWAYS
						, FILE_ATTRIBUTE_TEMPORARY | FILE_FLAG_DELETE_ON_CLOSE
						, NULL );

		if( hPostFile == INVALID_HANDLE_VALUE )
		{
			CloseHandle( hReadPipe );
			CloseHandle( hWritePipe );
			return SendDefaultHttpResponse( 500, bClose, __LINE__ );
		}

		DWORD dwWritten;
		WriteFile( hPostFile, m_hReqBody.GetBuffer(), m_hReqBody.GetLength(), &dwWritten, NULL );
	}
*/
/* 
	STARTUPINFO si = {0};

	si.cb = sizeof( STARTUPINFO );
	si.dwFlags = STARTF_USESTDHANDLES;
	si.hStdInput = hReadPipe;
	si.hStdOutput = hWritePipe;
	si.hStdError = hWritePipe;

	PROCESS_INFORMATION pi;


	WCHAR* pwstrExe = malloc_char2wchar( pszFile );
	WCHAR* pwstrCurDir = malloc_char2wchar( pszFile );
	WCHAR* p = pwstrCurDir;

	// --------------------------------------------------------------
	MyVarMem vmEnv;
	m_hashEnv.SeekToFirst();

	do{
		vmEnv.Add( m_hashEnv.GetCurrentKey() );
		vmEnv.Add( "=" );
		vmEnv.Add( m_hashEnv.GetCurrentValue() );
		vmEnv.Add( '\0', 1 );
	}while(m_hashEnv.SeekNext());

	while( *p != '\0' ) p++;
	while( *p != '\\' ) *p-- = '\0';
	
	BOOL bRet = CreateProcess( 
		pwstrExe, NULL, NULL, NULL, TRUE, DETACHED_PROCESS, vmEnv.GetBuffer(), pwstrCurDir, &si, &pi );

	free(pwstrExe);
	free(pwstrCurDir);


	if( bRet )
	{
		DWORD dwWritten = 0;
		DWORD dwRead = 0;
		CloseHandle( pi.hThread );

		// send post data
		if( m_hrHttpReq.HttpCmd == HTTPPOST )
		{
			WriteFile( hWritePipe, m_hReqBody.GetBuffer(), m_hReqBody.GetLength(), &dwWritten, NULL );
		}

		char szBuf[4096];

		ReadFile( hReadPipe, szBuf, 4096, &dwRead, 0 );
		SendData( szBuf, dwWritten );
	}

	CloseHandle( hReadPipe );
	CloseHandle( hWritePipe );

	return 500;
*/
}
