#include <memory.h>
#include <stdlib.h>
#include "MyVarMem.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

MyVarMem::MyVarMem()
{
	m_pBuffer = NULL;
	m_nBlockSize = 512;
	m_nBufferLen = 0;
}

MyVarMem::~MyVarMem()
{
	if(m_pBuffer != NULL)
	{
		free(m_pBuffer);
	}
}

//-----------------------------------------------------------------------------
//	@detail
//		擪Ƀf[^ǉ
//	@param
//		const void* pAddDat		ǉf[^
//		int nDataLen		
//	@return
//			ǉꂽf[^
//		s	0
//-----------------------------------------------------------------------------
size_t MyVarMem::AddHead( const void* pAddData, size_t nDataLen)
{
	if( pAddData == NULL )
		return 0;	
	
	void* pNewBuffer = NULL;

	if(m_pBuffer == NULL)
	{
		// ubNTCY̍쐬
		m_pBuffer = malloc(m_nBlockSize);
		
		// 1oCg 0 
		if(m_pBuffer != NULL)
		{
			memset((char*)m_pBuffer, 0, sizeof(m_nBlockSize));	// 2001/08/13
			//((char*)m_pBuffer)[0] = '\0';
			// Terminator
			m_nBufferLen = 0;
		}
	}

	// Alloc̈́Am_nBufferLen + 1
	size_t nNewTotal = nDataLen + m_nBufferLen + 1;
	// y[W쐬
	int nNewPage = (int)(nNewTotal / m_nBlockSize)
									+ ((nNewTotal % m_nBlockSize) ? 1 : 0);

	pNewBuffer = malloc(nNewPage * m_nBlockSize);
		
	if( pNewBuffer == NULL )
	{
		return 0;
	}

	// Vf[^ɔzu
	memcpy(pNewBuffer, pAddData, nDataLen);

	// 炠f[^ɔzu
	memcpy((char*)pNewBuffer + nDataLen, m_pBuffer, m_nBufferLen);

	free(m_pBuffer);
	m_pBuffer = pNewBuffer;

	m_nBufferLen = nNewTotal - 1;	// \0pɒǉ1oCgtotal
	((char*)m_pBuffer)[nNewTotal] = '\0';

	return nDataLen;
}

//-----------------------------------------------------------------------------
//	@detail
//		f[^ǉ
//	@param
//		const char* pszAddData		ǉf[^ NULLI[
//	@return
//			ǉꂽf[^
//		s	0
//-----------------------------------------------------------------------------
size_t MyVarMem::Add( const char* pszAddData )
{
	if( pszAddData ==NULL )
		return 0;

	char* p = (char*)pszAddData;
	for(size_t ii = 0; *p; p++, ii++);

	return Add((const void*)pszAddData, ii);

}

//-----------------------------------------------------------------------------
//	@detail
//		f[^ǉ
//	@param
//		const void* pAddData		ǉf[^
//		int nDataLen		
//	@return
//			ǉꂽf[^
//		s	0
//-----------------------------------------------------------------------------
size_t MyVarMem::Add( const void* pAddData, size_t nDataLen)
{
	if(( nDataLen == 0 )||( pAddData ==NULL ))
		return 0;

	void* pNewBuffer = NULL;

	if(m_pBuffer == NULL)
	{
		// ubNTCY̍쐬
		m_pBuffer = malloc(m_nBlockSize);
		
		if(m_pBuffer != NULL)
		{
			memset((char*)m_pBuffer, 0x00, m_nBlockSize);	// 2001/08/13
			m_nBufferLen = 0;
		}
	}

	// Alloc̈́Am_nBufferLen + 1
	size_t nNewTotal = nDataLen + m_nBufferLen + 1;
	size_t nOldTotal = m_nBufferLen + 1;
	// y[W쐬
	int nNewPage = (int)(nNewTotal / m_nBlockSize)
									+ ((nNewTotal % m_nBlockSize) ? 1 : 0);

	int nOldPage = (int)(nOldTotal / m_nBlockSize)
								+ ((nOldTotal % m_nBlockSize) ? 1 : 0);

	if(nNewPage > nOldPage)
	{
		pNewBuffer = realloc(m_pBuffer, (nNewPage * m_nBlockSize));
		if( pNewBuffer == NULL )
		{
			return 0;
		}
	
		m_pBuffer = pNewBuffer;
	}

	memcpy((char*)m_pBuffer + m_nBufferLen, pAddData, nDataLen);
	m_nBufferLen = nNewTotal - 1;	// \0pɒǉ1oCgtotal
	((char*)m_pBuffer)[m_nBufferLen] = '\0';

	return nDataLen;
}

//-----------------------------------------------------------------------------
//	@detail
//		mۂJ܂B
//	@param
//		
//	@return
//		
//-----------------------------------------------------------------------------
void MyVarMem::Clear()
{
	if(m_pBuffer)
	{
		free(m_pBuffer);
		m_pBuffer = NULL;
		m_nBufferLen = 0;
	}
}

